<html lang="en">
<head>
<title>Insert - psgml</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="psgml">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="up" href="Edit.html#Edit" title="Edit">
<link rel="prev" href="Edit.html#Edit" title="Edit">
<link rel="next" href="Complete.html#Complete" title="Complete">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Insert"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="Complete.html#Complete">Complete</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="Edit.html#Edit">Edit</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="Edit.html#Edit">Edit</a>
<hr>
</div>

<!-- node-name,  next,  previous,  up -->
<h3 class="section">8.1 Inserting Markup</h3>

<!-- erik says "inserts" ?? -->
<p>The commands that insert start-tags works only if the document has an
associated DTD.

   <p>Keyboard commands for inserting:

     
<a name="index-C_002dc-_003c-61"></a>
<a name="index-sgml_002dinsert_002dtag-62"></a>
<dl><dt><kbd>C-c &lt;</kbd><dd>Will ask, for the tag to insert, in the mini-buffer with completion on the
tags that are valid at point (<code>sgml-insert-tag</code>).

     <p>If <code>sgml-auto-insert-required-elements</code> is non-nil, tags for elements
required between the inserted tags will also be inserted.

     <p>The list of valid tags, computed for a position in the buffer, will
contain:

          <ol type=1 start=1>
<li>The end-tag for the current element, if it can be ended at the position. 
Furthermore it will contain end-tags for enclosing elements if the
necessary omissible end-tag declarations have been made in the DTD.

          <li>The start-tags of all elements that could occur after point.  If
<code>sgml-omittag-transparent</code> is nil, the above will be limited to the
elements that can occur within the current element.
          </ol>

     <p><a name="index-C_002dc-C_002de-63"></a><a name="index-sgml_002dinsert_002delement-64"></a><a name="index-sgml_002dinsert_002dend_002dtag_002don_002dnew_002dline-65"></a><br><dt><kbd>C-c C-e</kbd><dd>Insert start and end-tags for an element
(<code>sgml-insert-element</code>).  The name of the element is read
from the mini-buffer with completion on valid elements.  If
<code>sgml-insert-end-tag-on-new-line</code> is non-nil or the
element has element content, the end-tag will be inserted on a
new line after the start-tag.

     <p><a name="index-sgml_002domittag_002dtransparent-66"></a>If <code>sgml-omittag-transparent</code> is nil, the list of valid elements
will only contain the elements that can be in the content of the current
element.

     <p><a name="index-sgml_002dauto_002dinsert_002drequired_002delements-67"></a><a name="index-sgml_002dinsert_002dmissing_002delement_002dcomment-68"></a>Required elements in the content will be automatically inserted if the
option <code>sgml-auto-insert-required-elements</code> is non-nil. 
When the content model demands an element but there is more
than one to choose from, a comment can be inserted with the
available choices if the option
<code>sgml-insert-missing-element-comment</code> is non-nil.

     <p><a name="index-C_002dc-C_002di-69"></a><a name="index-sgml_002dadd_002delement_002dto_002delement-70"></a><br><dt><kbd>C-c C-i</kbd><dd>Inserts a new element in the current element where it is legal. Prompts
for element name with completion. The completion list contains all
elements that could be added to the current element somewhere, without
making the content invalid. This assumes that the content is valid to
begin with. Currently this list only has regular elements, not
inclusions. The new element will be inserted as late as possible in the
current element (unless prefix argument is given, then as early as
possible.)

     <p><a name="index-C_002dc-C_002dr-71"></a><a name="index-sgml_002dtag_002dregion-72"></a><br><dt><kbd>C-c C-r</kbd><dd>Makes the region into a new element (<code>sgml-tag-region</code>).  Reads
element name from mini-buffer with completion as for <kbd>C-c C-e</kbd>.

     <p><a name="index-C_002dc-_002f-73"></a><a name="index-sgml_002dinsert_002dend_002dtag-74"></a><br><dt><kbd>C-c /</kbd><dd>Inserts an end-tag for the current element (<code>sgml-insert-end-tag</code>).

     <!-- note that this keybinding doesn't follow the conventions for -->
<!-- major-modes. Perhaps warn that this binding may change in the next -->
<!-- major release? -->
<p><a name="index-C_002dc-RET-75"></a><a name="index-sgml_002dsplit_002delement-76"></a><br><dt><kbd>C-c RET</kbd><dd>Split the current element at point.  If repeated, the containing element
will be split before the beginning of then current element.

     <p>Typical use is to start a new paragraph element when inside a paragraph.

     <p><a name="index-C_002dc-_002b-77"></a><a name="index-sgml_002dinsert_002dattribute-78"></a><br><dt><kbd>C-c +</kbd><dd>Read attribute name and value from mini-buffer and insert attribute
specification (<code>sgml-insert-attribute</code>).  If point is immediately
after a start-tag, this command operates on that start-tag.  Otherwise
the command will operate on the element after point.

     <p>The attribute name will be read with completion.  If the attribute has a
token list as declared value the attribute value will also be read with
completion.  The prompt for attribute value will typically look like:

     <pre class="example">          Value for <var>attribute</var> (<var>type</var> Default: <var>current value</var>):
     </pre>
     <!-- note that this keybinding doesn't follow the conventions for -->
<!-- major-modes. Perhaps warn that this binding may change in the next -->
<!-- major release? -->
<p><a name="index-C_002dc-C_002du-C_002dm-79"></a><a name="index-sgml_002dcustom_002dmarkup-80"></a><br><dt><kbd>C-c C-u C-m</kbd><dd>Give keyboard access to the customized part of the Markup menu. 
Emacs will prompt for the markup to insert using the menu line as
selector. (See <var>sgml-custom-markup</var> below.)

   </dl>

   <p>Menu bar:

     <dl>
<dt>`<samp><span class="samp">Markup</span></samp>'<dd>Selecting from this menu will insert markup.  The menu contains
sub menus with tags and with entities, some other markup and a user
defined section.

     <p>Sub menus:

     <br><dt>`<samp><span class="samp">Insert element</span></samp>'<dd>Pops up a menu of valid elements and insert start and end-tags for
the selected element.  Selections from the menu works like the <kbd>C-c
C-e</kbd> command.

     <br><dt>`<samp><span class="samp">Insert start-tag</span></samp>'<dd>Pops up a menu of valid start-tags and insert the selected tag.  The
menu has the same start-tags as the completion list for <kbd>C-c &lt;</kbd>.

     <br><dt>`<samp><span class="samp">Insert end-tag</span></samp>'<dd>Pops up a menu of valid end-tags and insert the selected tag.

     <br><dt>`<samp><span class="samp">Tag region</span></samp>'<dd>Pops up a menu of valid elements and tag the region with the
selection.  Selections from the menu works like the <kbd>C-c C-r</kbd>
command.

     <br><dt>`<samp><span class="samp">Insert entity</span></samp>'<dd>Menu of all general entities defined in the DTD.

     <br><dt>`<samp><span class="samp">Add Element to Element</span></samp>'<dd>Pops up a menu of all elements valid somewhere in the current element. 
The menu contains all elements that could be added to the current
element somewhere, without making the content invalid. The new element
will be inserted as late as possible in the current element.

     <br><dt>`<samp><span class="samp">Insert attribute</span></samp>'<dd>Pops up a menu with all the attributes of an element.  The element is
either the one which start-tag is immediately before point or the
element after point.  Selecting from this menu edits the attribute
specification list for the element.

     <p>The menu has a sub menu for every attribute which declared value is a
token list.  The rest of the attributes are collected in one sub menu. 
For the token list attributes, selecting a value will insert that
attribute-value pair.  Selecting some other attribute reads the
attribute-value from the mini-buffer and inserts the attribute value
pair. 
</dl>

   <p><a name="index-S_002d_0040key_007bmouse_002d1_007d-81"></a>A menu is also available directly with a mouse button click in the
buffer.  In GNU Emacs it is the first mouse button combined with shift
(<kbd>S-&lt;mouse-1&gt;</kbd>).  In Lucid Emacs it is bound to the third mouse
button.  The mouse button click will pop-up a menu of valid tags or a
menu of attributes if the point is in a start-tag.  The attributes menu
works as the &ldquo;Insert attribute&rdquo; menu from the menu-bar.  The tags list
is the list of valid tags described above for command <kbd>C-c &lt;</kbd>. 
Selection from the tags menu works like the <kbd>C-c &lt;</kbd> command, with
the following exception:

   <p>You can tag a region, with start and end-tag.  There are two ways to
indicate the region to mark:

     <ol type=1 start=1>
<li>Use the normal mouse commands to mark region.

     <p>For this to work you must either use <dfn>transient mark mode</dfn>
(see <a href="../emacs/Transient-Mark.html#Transient-Mark">Transient Mark Mode</a>) or set the option <code>sgml-tag-region-if-active</code> to non-nil
(don't set this unless you are sure that you want it).

     <li>Alternatively make a secondary selection, this is done by holding down
the meta key and using the mouse buttons. 
See <a href="../emacs/Secondary-selection.html#Secondary-selection">Secondary selection</a>. 
Some window managers intercept these events, which makes it hard use the
secondary selection in Emacs.
        </ol>

<div class="defun">
&mdash; User Option: <b>sgml-balanced-tag-edit</b><var><a name="index-sgml_002dbalanced_002dtag_002dedit-82"></a></var><br>
<blockquote><p>If non-nil, inserting a start-tag using the context menu will also
insert the corresponding end-tag. 
</p></blockquote></div>

<div class="defun">
&mdash; User Option: <b>sgml-auto-insert-required-elements</b><var><a name="index-sgml_002dauto_002dinsert_002drequired_002delements-83"></a></var><br>
<blockquote><p>If non-nil, automatically inserts required elements in the content
of an inserted element. 
</p></blockquote></div>

<div class="defun">
&mdash; User Option: <b>sgml-omittag-transparent</b><var><a name="index-sgml_002domittag_002dtransparent-84"></a></var><br>
<blockquote><p>If non-nil, will show legal tags inside elements with omissible start-tags
and legal tags beyond omissible end-tags. 
</p></blockquote></div>

<div class="defun">
&mdash; User Option: <b>sgml-tag-region-if-active</b><var><a name="index-sgml_002dtag_002dregion_002dif_002dactive-85"></a></var><br>
<blockquote><p>If non-nil, the `<samp><span class="samp">Insert tags</span></samp>' menu will tag a region if the region
is considered active by emacs.  If nil, region must be active and
<code>transient-mark-mode</code> must be on for the region to be tagged. 
</p></blockquote></div>

<div class="defun">
&mdash; User Option: <b>sgml-custom-markup</b><var><a name="index-sgml_002dcustom_002dmarkup-86"></a></var><br>
<blockquote><p>Menu entries to be added to the Markup menu.  The value should be a list
of lists of two strings.  The first string is the menu line and the
second string is the text inserted when the menu item is selected.  The
second string can contain a `<samp><span class="samp">\r</span></samp>' where the cursor should be left. 
Also, if a selection is made according to the same rules as for the
<kbd>S-mouse-1</kbd> menu, the selection is replaced with the second string
and `<samp><span class="samp">\r</span></samp>' is replaced with the selection.

        <p>Example:

     <pre class="example">            (("Version1" "&lt;![%Version1[\r]]&gt;")
             ("New page"  "&lt;?NewPage&gt;"))
     </pre>
        </blockquote></div>

<div class="defun">
&mdash; User Option: <b>sgml-insert-missing-element-comment</b><var><a name="index-sgml_002dinsert_002dmissing_002delement_002dcomment-87"></a></var><br>
<blockquote><p>If non-nil, and sgml-auto-insert-required-elements also true,
<code>sgml-insert-element</code> will insert a comment if there is an
element required but there is more than one to choose from. 
</p></blockquote></div>

<div class="defun">
&mdash; User Option: <b>sgml-insert-end-tag-on-new-line</b><var><a name="index-sgml_002dinsert_002dend_002dtag_002don_002dnew_002dline-88"></a></var><br>
<blockquote><p>If non-nil, <code>sgml-insert-element</code> will put the end-tag on
a new line after the start-tag.  Useful on slow terminals if you
find the end-tag after the cursor irritating. 
</p></blockquote></div>

<!--  -->
</body></html>

